import { Extension, callOrReturn } from '@tiptap/core';
import { gapCursor } from 'prosemirror-gapcursor';

const Gapcursor = Extension.create({
    name: 'gapCursor',
    addProseMirrorPlugins() {
        return [
            gapCursor(),
        ];
    },
    extendNodeSchema(extension) {
        var _a;
        const context = { options: extension.options };
        return {
            allowGapCursor: (_a = callOrReturn(extension.config.allowGapCursor, context)) !== null && _a !== void 0 ? _a : null,
        };
    },
});

export default Gapcursor;
export { Gapcursor };
//# sourceMappingURL=tiptap-extension-gapcursor.esm.js.map
